%define 	pname mysql-iworx
%define		rname mysql
%define 	pversion 4.0.21
%define 	bversion 8
%define 	rpmrelease iworx
%define		iworxuser iworx
%define		iworxuid  250
%define		iworxgid  250
%define		iworxgroup iworx
%define		iworxdir /home/interworx
%define		iworxbindir %{iworxdir}/bin
%define		iworxsysconfdir %{iworxdir}/etc
%define		iworxdatadir %{iworxdir}/var/lib
%define		iworxsharedir %{iworxdir}/var/share
%define		iworxrundir %{iworxdir}/var/run
%define     iworxlibdir %{iworxdir}/lib
%define     iworxincdir %{iworxdir}/include

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define 	build_rht_90   0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_fdr_30   0
%define		build_fdr_40   0
%define		build_fdr_80   0
%define		build_fdr_90   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0
%define		build_rhe_4x   0
%define		build_rhe_5x   0
%define		build_rhe_6x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_fdr30: 	%{expand: %%define build_fdr_30   1}}
%{?_with_fdr40: 	%{expand: %%define build_fdr_40   1}}
%{?_with_fdr80: 	%{expand: %%define build_fdr_80   1}}
%{?_with_fdr90: 	%{expand: %%define build_fdr_90   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}
%{?_with_rhe4x: 	%{expand: %%define build_rhe_4x   1}}
%{?_with_rhe5x: 	%{expand: %%define build_rhe_5x   1}}
%{?_with_rhe6x: 	%{expand: %%define build_rhe_6x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements
%if %{build_rht_90}
%define		oscode rht90
%define 	ostype RedHat 9
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		oscode cos3x
%define 	ostype CentOS 3.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		oscode fdr10
%define 	ostype Fedora Core 1
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		oscode fdr20
%define 	ostype Fedora Core 2
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_30}
%define		oscode fdr30
%define 	ostype Fedora Core 3
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_40}
%define		oscode fdr40
%define 	ostype Fedora Core 4
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags} -lstdc++
%define		build_unk 0
%endif

%if %{build_fdr_80}
%define		oscode fdr80
%define 	ostype Fedora Core 8
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags} -lstdc++
%define		build_unk 0
%endif

%if %{build_fdr_90}
%define		oscode fdr90
%define 	ostype Fedora Core 9
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags} -lstdc++
%define		build_unk 0
%endif

%if %{build_whb_3x}
%define		oscode whb3x
%define 	ostype White Box 3.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		oscode rhe2x
%define 	ostype RedHat Enterprise 2.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		oscode rhe3x
%define 	ostype RedHat Enterprise 3.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_4x}
%define		oscode rhe4x
%define 	ostype RedHat Enterprise 4.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_5x}
%define		oscode rhe5x
%define 	ostype RedHat Enterprise 5.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags} -lstdc++
%define		build_unk 0
%endif

%if %{build_rhe_6x}
%define		oscode rhe6x
%define 	ostype RedHat Enterprise 6.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags} -lstdc++
%define		build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define 	ostype Unknown Distribution
%define		release %{bversion}.%{rpmrelease}
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	MySQL: a very fast and reliable SQL database server (InterWorx)
Name: 		%{pname}
Version: 	%{pversion}
Release: 	%{release}
License:	GPL

Group:		Applications/Databases
Source0:	%{rname}-%{version}.tar.gz
URL:		http://www.mysql.com/

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C.
Packager:	    Paul Oehler <poehler@interworx.com>

ExclusiveOS:	Linux
BuildRoot:	%{_tmppath}/%{rname}-%{version}-root

Source1:	mysql-iworx-my.cnf

#%if %{build_rhe_5x} || %{build_fdr_80} || %{build_fdr_90}
Patch0:  	mysql-4.0.21-pthread1.patch
#%endif
Patch1:		mysql-4.0.21-gcc-4.2-max.patch

%description
The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
and robust SQL (Structured Query Language) database server. MySQL Server
is intended for mission-critical, heavy-load production systems as well
as for embedding into mass-deployed software. MySQL is a trademark of
MySQL AB.

The MySQL software has Dual Licensing, which means you can use the MySQL
software free of charge under the GNU General Public License
(http://www.gnu.org/licenses/). You can also purchase commercial MySQL
licenses from MySQL AB if you do not wish to be bound by the terms of
the GPL. See the chapter "Licensing and Support" in the manual for
further info.

The MySQL web site (http://www.mysql.com/) provides the latest
news and information about the MySQL software. Also please see the
documentation and the manual for more information.

%prep
%setup -q -n %{rname}-%{version}

#%if %{build_rhe_5x} || %{build_fdr_80} || %{build_fdr_90}
%patch0 -p1
#%endif

%patch1 -p1

# Try detecting newest gcc (some distributions have got more then one compiler)
[ -f %{_tmppath}/%{rname}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{rname}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{rname}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{rname}-%{pversion}-gcc
fi

# Display compilation flags and OS with nice colors
[ -f %{_tmppath}/%{rname}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{rname}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{rname}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{rname}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{rname}-%{pversion}-show_flags
%{_tmppath}/%{rname}-%{pversion}-show_flags
[ -f %{_tmppath}/%{rname}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{rname}-%{pversion}-show_flags

%build
# Use our own copy of glibc

OTHER_LIBC_DIR=/usr/local/mysql-glibc
USE_OTHER_LIBC_DIR=""
if test -d "$OTHER_LIBC_DIR"
then
  USE_OTHER_LIBC_DIR="--with-other-libc=$OTHER_LIBC_DIR"
fi

# Clean up the BuildRoot first
[ "%{buildroot}" != "/" ] && [ -d %{buildroot} ] && rm -rf %{buildroot};
mkdir -p %{buildroot}%{_libdir}/mysql

#
# Use MYSQL_BUILD_PATH so that we can use a dedicated version of gcc
#
PATH=${MYSQL_BUILD_PATH:-/bin:/usr/bin}
export PATH

# Use gcc for C and C++ code (to avoid a dependency on libstdc++ and
# including exceptions into the code
#if [ -z "$CXX" -a -z "$CC" ]
#then
export CC="gcc"
export CXX="gcc"
%if %{build_fdr_40}
export CXX="g++"
%endif
%if %{build_fdr_80}
export CXX="g++"
%endif
%if %{build_fdr_90}
export CXX="g++"
%endif
#fi

#export CFLAGS="%{ccflags}"
#export LDFLAGS="%{ldflags}"

export CFLAGS="%{optflags} -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -fno-strict-aliasing -fwrapv"
export LDFLAGS="%{ldflags}"

if [ `egrep -c 'Linuxthreads' /usr/include/pthread.h` -eq "0" ]; then
	echo '/* Linuxthreads */' >> /usr/include/pthread.h
fi

# Now build the statically linked 4.0 binary
# The --enable-assembler simply does nothing on systems that does not
# support assembler speedups.
sh -c  "PATH=\"${MYSQL_BUILD_PATH:-$PATH}\" \
	LDFLAGS=\"${LDFLAGS:-$MYSQL_BUILD_LDFLAGS}\" \
	CC=\"${CC:-$MYSQL_BUILD_CC}\" \
	CFLAGS=\"${MYSQL_BUILD_CFLAGS:-$RPM_OPT_FLAGS -fPIC}\" \
	CXX=\"${CXX:-$MYSQL_BUILD_CXX}\" \
	CXXLD=\"${CXX:-$MYSQL_BUILD_CXX}\" \
	CXXFLAGS=\"${MYSQL_BUILD_CXXFLAGS:-$RPM_OPT_FLAGS \
	          -felide-constructors -fno-exceptions -fno-rtti \
		  }\" \
	./configure                                           \
 	    $*                                                \
	    --enable-assembler                                \
            --with-mysqld-user=%{iworxuser}                   \
            --with-unix-socket-path=%{iworxrundir}/mysql.sock \
            --prefix=%{iworxdir}                              \
            --bindir=%{iworxbindir}/mysql                     \
            --sbindir=%{iworxbindir}/mysql                    \
            --localstatedir=%{iworxdatadir}/mysql             \
            --libexecdir=%{iworxbindir}/mysql                 \
            --sysconfdir=%{iworxsysconfdir}                   \
            --datadir=%{iworxsharedir}                        \
            --libdir=%{iworxlibdir}                           \
            --mandir=/DELETE_ME                               \
            --infodir=/DELETE_ME                              \
            --includedir=%{iworxincdir}                       \
	    --enable-thread-safe-client                       \
%ifarch i386
%if !%{build_fdr_40} 
%if !%{build_rhe_4x}
            --with-named-thread-libs="-lpthread"              \
%endif
%endif
%endif
            $USE_OTHER_LIBC_DIR                               \
            --without-embedded-server                         \
            --without-berkeley-db                             \
            --without-innodb                                  \
            --without-vio                                     \
            --without-openssl                                 \
            --without-bench                                   \
            --without-debug                                   \
            --without-extra-tools                             \
            --without-docs"

%{__make} %{?_smp_mflags}

%install

%{__make} install-strip DESTDIR=%{buildroot}

# kill stuff we don't need
rm -rf %{buildroot}%{iworxdir}/mysql-test
rm -rf %{buildroot}%{_prefix}
rm -rf %{buildroot}/DELETE_ME

# kill all other crap we don't need
rm -f %{buildroot}%{iworxbindir}/mysql/comp_err \
	%{buildroot}%{iworxbindir}/mysql/isamchk \
	%{buildroot}%{iworxbindir}/mysql/isamlog \
	%{buildroot}%{iworxbindir}/mysql/make_win_binary_distribution \
	%{buildroot}%{iworxbindir}/mysql/make_win_src_distribution \
	%{buildroot}%{iworxbindir}/mysql/msql2mysql \
	%{buildroot}%{iworxbindir}/mysql/myisamchk \
	%{buildroot}%{iworxbindir}/mysql/myisam_ftdump \
	%{buildroot}%{iworxbindir}/mysql/myisamlog \
	%{buildroot}%{iworxbindir}/mysql/myisampack \
	%{buildroot}%{iworxbindir}/mysql/mysqlaccess \
	%{buildroot}%{iworxbindir}/mysql/mysqlbinlog \
	%{buildroot}%{iworxbindir}/mysql/mysqlbug \
	%{buildroot}%{iworxbindir}/mysql/mysql_config \
	%{buildroot}%{iworxbindir}/mysql/mysql_convert_table_format \
	%{buildroot}%{iworxbindir}/mysql/mysqld_multi \
	%{buildroot}%{iworxbindir}/mysql/mysqldumpslow \
	%{buildroot}%{iworxbindir}/mysql/mysql_explain_log \
	%{buildroot}%{iworxbindir}/mysql/mysql_find_rows \
	%{buildroot}%{iworxbindir}/mysql/mysql_fix_extensions \
	%{buildroot}%{iworxbindir}/mysql/mysql_fix_privilege_tables \
	%{buildroot}%{iworxbindir}/mysql/mysqlhotcopy \
	%{buildroot}%{iworxbindir}/mysql/mysqlimport \
	%{buildroot}%{iworxbindir}/mysql/mysql_install \
	%{buildroot}%{iworxbindir}/mysql/mysqlmanagerc \
	%{buildroot}%{iworxbindir}/mysql/mysqlmanager-pwgen \
	%{buildroot}%{iworxbindir}/mysql/mysql_secure_installation \
	%{buildroot}%{iworxbindir}/mysql/mysql_setpermission \
	%{buildroot}%{iworxbindir}/mysql/mysqlshow \
	%{buildroot}%{iworxbindir}/mysql/mysql_tableinfo \
	%{buildroot}%{iworxbindir}/mysql/mysqltest \
	%{buildroot}%{iworxbindir}/mysql/mysql_waitpid \
	%{buildroot}%{iworxbindir}/mysql/mysql_zap \
	%{buildroot}%{iworxbindir}/mysql/pack_isam \
	%{buildroot}%{iworxbindir}/mysql/perror \
	%{buildroot}%{iworxbindir}/mysql/replace \
	%{buildroot}%{iworxbindir}/mysql/resolveip

mkdir -m0700 -p %{buildroot}%{iworxsysconfdir}
install -m0600 %{SOURCE1} %{buildroot}%{iworxsysconfdir}/my.cnf

%post

#
# symlink mysqld to it's real location. it **really** wants to
# live in a /bin dir
#ln -fs %{iworxbindir}/mysql/mysqld %{iworxbindir}/mysqld

#
# make iworx-db
ln -fs %{iworxbindir}/mysql/mysqld %{iworxbindir}/iworx-db

#if [ -f %{_sysconfdir}/init.d/iworx ]; then
#	%{_sysconfdir}/init.d/iworx restart
#fi

%postun

#
# only if we're erasing
if [ "$1" = "0" ]; then
	[ -L %{iworxbindir}/iworx-db ] && rm -f %{iworxbindir}/iworx-db
	[ -L %{iworxbindir}/mysqld ] && rm -f %{iworxbindir}/mysqld
fi

# Clean up the BuildRoot
%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%pre

# make the iworx group (if needed)
/bin/grep "^%{iworxgroup}:" /etc/group >/dev/null || groupadd -r %{iworxgroup} -g %{iworxgid}

# make the vchkpw group (if needed)
/bin/grep "vchkpw:" /etc/group > /dev/null || groupadd -r -g 104 vchkpw

# make the iworx  user (if needed)
/bin/grep "^%{iworxuser}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
	-u %{iworxuid} -g %{iworxgroup} -G vchkpw -d %{iworxdir} \
	-s /bin/bash -c %{name} -r -m %{iworxuser}

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: mysql-iworx package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

%files
%defattr(-,iworx.iworx,0700)

%attr(0600,iworx,iworx) %{iworxsysconfdir}/my.cnf
%attr(0700,iworx,iworx) %{iworxbindir}/mysql/*
%attr(0700,iworx,iworx) %{iworxsharedir}/mysql/*
%attr(0644,iworx,iworx) %{iworxlibdir}/mysql/*
%attr(0700,iworx,iworx) %{iworxincdir}/mysql/*

%attr(0700,iworx,iworx) %dir %{iworxbindir}/mysql
%attr(0700,iworx,iworx) %dir %{iworxsharedir}/mysql
%attr(0700,iworx,iworx) %dir %{iworxincdir}/mysql
%attr(0711,iworx,iworx) %dir %{iworxlibdir}/mysql

%changelog 
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Tue Nov 10 2009 Paul Oehler <poehler@interworx.com>
- fixed libdir perms
* Tue Nov 10 2009 Paul Oehler <poehler@interworx.com>
- added iworxuid and iworxgid
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- Added support for Fedora 8
* Tue Feb 05 2005 Chris Wells <clwells@nexcess.net>
- Added include dir
* Sun Sep 20 2004 Chris Wells <clwells@nexcess.net>
- Fixing iworx-db symlink bug
- update to 4.0.21
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
